use std::error;

use crate::utils::urlencoded::UrlEncodeData;

#[derive(Debug, PartialEq, Eq, PartialOrd, Ord, Clone)]
pub struct Uri {
    pub(super) parts: Vec<UrlEncodeData>,
}

#[derive(Debug, PartialEq, Eq, PartialOrd, Ord, Clone)]
pub struct RawUri {
    pub(super) raw_string: String,
    pub(super) infinte_end: bool,
    pub(super) parts: Vec<RawUriElement>,
}

#[derive(Debug, PartialEq, Eq, PartialOrd, Ord, Clone)]
pub enum RawUriElement {
    Variable,
    Name(UrlEncodeData),
}

#[derive(Debug, PartialEq, Eq, PartialOrd, Ord)]
pub enum UriError {
    InvalidUriEncoding,
}

#[derive(Debug)]
pub struct ParseUriError {
    pub error: UriError,
}
impl std::fmt::Display for ParseUriError {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(f, "{:?}", self)
    }
}

impl error::Error for ParseUriError {}
